package pwc.taxtech.atms.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import pwc.taxtech.atms.dto.OperationLogDto;
import pwc.taxtech.atms.dto.PagingResultDto;
import pwc.taxtech.atms.dto.QueryOperateParamDto;
import pwc.taxtech.atms.service.OperationLogService;

/** @see PwC.Tax.Tech.Atms.WebApi.Controllers.OperationLogController.cs */
@RestController
@RequestMapping("/api/v1/operationlog/")
public class OperationLogController {
    
    private static Logger logger = LoggerFactory.getLogger(OperationLogController.class);
    
    @Autowired
    private OperationLogService operationLogService;

    @ApiOperation(value = "查询日志")
    @ApiImplicitParam(name = "queryOperateParamDto", value = "queryOperateParamDto", required = true, dataType = "QueryOperateParamDto")
    @RequestMapping(value = "getorgloglist", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public @ResponseBody PagingResultDto<OperationLogDto> getOperationLogList(@RequestBody QueryOperateParamDto queryOperateParamDto) {
        logger.debug("OperationLogController /getorgloglist");
        return operationLogService.getOperationLogList(queryOperateParamDto);
    }
}
