package pwc.taxtech.atms.controller;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import io.swagger.annotations.ApiOperation;
import pwc.taxtech.atms.dto.ProjectClientDto;
import pwc.taxtech.atms.dto.ServiceTypeDto;
import pwc.taxtech.atms.service.ProjectService;

@RestController
@RequestMapping("/api/v1/project")
public class ProjectController {

    /** @see PwC.Tax.Tech.Atms.WebApi\Controllers\ProjectController.cs */

    private static Logger logger = LoggerFactory.getLogger(ProjectController.class);

    @Autowired
    private ProjectService projectService;

    @ApiOperation(value = "listService", notes = "Get service list")
    @RequestMapping(value = "listService", method = RequestMethod.GET)
    public @ResponseBody List<ServiceTypeDto> getServiceList() {
        logger.info("/api/v1/project/listService");
        return projectService.getServiceList();
    }

    @ApiOperation(value = "getProjectClientList", notes = "Get project Client list")
    @RequestMapping(value = "getProjectClientList", method = RequestMethod.GET)
    public @ResponseBody List<ProjectClientDto> getProjectClientList() {
        logger.info("/api/v1/project/getProjectClientList");
        return projectService.getProjectClientList();
    }

}
