package pwc.taxtech.atms.service;

import java.util.List;

import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.organization.DimensionRoleDto;
import pwc.taxtech.atms.dto.organization.OrgRoleDtoList;
import pwc.taxtech.atms.dto.organization.OrganizationDto;
import pwc.taxtech.atms.dto.user.UpdateParam;
import pwc.taxtech.atms.dto.user.UserAndUserRoleSaveDto;
import pwc.taxtech.atms.dto.user.UserDto;
import pwc.taxtech.atms.dto.user.UserOrgDto;
import pwc.taxtech.atms.dto.user.UserOrgRoleDto;
import pwc.taxtech.atms.dto.user.UserOrganizationDto;
import pwc.taxtech.atms.dto.user.UserRoleDimensionValueDto;
import pwc.taxtech.atms.dto.user.UserRoleDisplayInfo;
import pwc.taxtech.atms.entitiy.UserRole;

public interface UserRoleService {

    OrgRoleDtoList getUserRoleByUserID(String userID);

    UserAndUserRoleSaveDto getSingleUserByUserId(String userId);

    List<UserRoleDisplayInfo> getAllUserRoleList(String serviceTypeID);

    List<UserRole> findAllUserRoles();

    UserRoleDisplayInfo getUserRoleListByUserID(String userID);

    UserOrganizationDto getUserRoleByOrgID(String userID, String orgID);

    List<DimensionRoleDto> getOrgBuAreaIndustryUser(String userID);

    @SuppressWarnings("rawtypes")
    OperationResultDto enableOrDisableUser(UpdateParam updateParam);

    @SuppressWarnings("rawtypes")
    OperationResultDto deleteUserRoleOrg(List<UserRoleDimensionValueDto> list);

    List<UserRoleDisplayInfo> getUserRoleByDimensionValueID(String parentDimensionID, String dimensionValueID);

    List<UserRoleDisplayInfo> getSpecialUserRoleByDimensionValueID(String parentDimensionID, String dimensionValueID);

    List<UserOrgRoleDto> getDimensionUserRoleList(String parentDimensionID, String dimensionValueID);

    @SuppressWarnings("rawtypes")
    OperationResultDto updateUserRoleDimension(List<UserRoleDimensionValueDto> userRoleList);

    @SuppressWarnings("rawtypes")
    OperationResultDto updateUserRoleOrganization(List<UserRoleDimensionValueDto> userRoleList);

    @SuppressWarnings("rawtypes")
    OperationResultDto deleteUserRoleDimension(List<UserRoleDimensionValueDto> userRoleList);

    OperationResultDto<?> updateUserRoleForDimension(List<UserRoleDimensionValueDto> userRoleList);

    UserDto getUserDtoByID(String userID);

    OrganizationDto getOrgDtoByID(String orgID);

    @SuppressWarnings("rawtypes")
    OperationResultDto updateUserDimensionNonAccess(UserRoleDimensionValueDto r);

    @SuppressWarnings("rawtypes")
    OperationResultDto updateUserRoleForOrg(List<UserRoleDimensionValueDto> userRoleList);

    @SuppressWarnings("rawtypes")
    OperationResultDto deleteUserRoleByOrgID(UserOrgDto userDto);
}
