package pwc.taxtech.atms.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import pwc.taxtech.atms.common.AtmsApiSettings;
import pwc.taxtech.atms.common.AuthUserHelper;
import pwc.taxtech.atms.dao.AccountMapper;
import pwc.taxtech.atms.dao.AccountMappingMapper;
import pwc.taxtech.atms.dao.AreaMapper;
import pwc.taxtech.atms.dao.AreaRegionMapper;
import pwc.taxtech.atms.dao.BusinessUnitMapper;
import pwc.taxtech.atms.dao.CustomerMapper;
import pwc.taxtech.atms.dao.DictionaryMapper;
import pwc.taxtech.atms.dao.DimensionMapper;
import pwc.taxtech.atms.dao.DimensionValueMapper;
import pwc.taxtech.atms.dao.DimensionValueOrgMapper;
import pwc.taxtech.atms.dao.EnterpriseAccountMapper;
import pwc.taxtech.atms.dao.EnterpriseAccountSetMapper;
import pwc.taxtech.atms.dao.EnterpriseAccountSetOrgMapper;
import pwc.taxtech.atms.dao.IndustryMapper;
import pwc.taxtech.atms.dao.MailQueueMapper;
import pwc.taxtech.atms.dao.MenuMapper;
import pwc.taxtech.atms.dao.MyStatisticAttributeMapper;
import pwc.taxtech.atms.dao.MyUserMapper;
import pwc.taxtech.atms.dao.OperationLogBasicDataMapper;
import pwc.taxtech.atms.dao.OperationLogEnterPriseMapper;
import pwc.taxtech.atms.dao.OrganizationMapper;
import pwc.taxtech.atms.dao.OrganizationStructureMapper;
import pwc.taxtech.atms.dao.PermissionMapper;
import pwc.taxtech.atms.dao.RegionMapper;
import pwc.taxtech.atms.dao.RoleCategoryMapper;
import pwc.taxtech.atms.dao.RoleMapper;
import pwc.taxtech.atms.dao.RolePermissionMapper;
import pwc.taxtech.atms.dao.ServiceTypeMapper;
import pwc.taxtech.atms.dao.StandardAccountMapper;
import pwc.taxtech.atms.dao.StatisticAttributeDimensionMapper;
import pwc.taxtech.atms.dao.StatisticAttributeMapper;
import pwc.taxtech.atms.dao.StockMapper;
import pwc.taxtech.atms.dao.UserDimensionValueMapper;
import pwc.taxtech.atms.dao.UserDimensionValueOrgMapper;
import pwc.taxtech.atms.dao.UserDimensionValueRoleMapper;
import pwc.taxtech.atms.dao.UserMapper;
import pwc.taxtech.atms.dao.UserOrganizationMapper;
import pwc.taxtech.atms.dao.UserOrganizationRoleMapper;
import pwc.taxtech.atms.dao.UserRoleMapper;
import pwc.taxtech.atms.service.OperationLogService;

public class AbstractService {
    protected final Logger logger = LoggerFactory.getLogger(this.getClass());
    
    @Autowired
    protected AuthUserHelper authUserHelper;
    @Autowired
    protected AtmsApiSettings atmsApiSettings;
    @Autowired
    protected OperationLogService operationLogService;

    @Autowired
    protected AreaMapper areaMapper;
    @Autowired
    protected AreaRegionMapper areaRegionMapper;
    @Autowired
    protected BusinessUnitMapper businessUnitMapper;
    @Autowired
    protected CustomerMapper customerMapper;
    @Autowired
    protected EnterpriseAccountMapper enterpriseAccountMapper;
    @Autowired
    protected EnterpriseAccountSetMapper enterpriseAccountSetMapper;
    @Autowired
    protected EnterpriseAccountSetOrgMapper enterpriseAccountSetOrgMapper;
    @Autowired
    protected AccountMappingMapper accountMappingMapper;
    @Autowired
    protected AccountMapper accountMapper;
    @Autowired
    protected MailQueueMapper mailQueueMapper;
    @Autowired
    protected MenuMapper menuMapper;
    @Autowired
    protected OperationLogBasicDataMapper operationLogBasicDataMapper;
    @Autowired
    protected OperationLogEnterPriseMapper operationLogEnterpriseMapper;
    @Autowired
    protected OrganizationMapper organizationMapper;
    @Autowired
    protected PermissionMapper permissionMapper;
    @Autowired
    protected RegionMapper regionMapper;
    @Autowired
    protected RolePermissionMapper rolePermissionMapper;
    @Autowired
    protected StandardAccountMapper standardAccountMapper;
    @Autowired
    protected UserMapper userMapper;
    @Autowired
    protected UserRoleMapper userRoleMapper;
    @Autowired
    protected DimensionMapper dimensionMapper;
    @Autowired
    protected DimensionValueMapper dimensionValueMapper;
    @Autowired
    protected StockMapper stockMapper;
    @Autowired
    protected MyStatisticAttributeMapper myStatisticAttributeMapper;
    @Autowired
    protected StatisticAttributeMapper statisticAttributeMapper;
    @Autowired
    protected DimensionValueOrgMapper dimensionValueOrgMapper;
    @Autowired
    protected UserDimensionValueOrgMapper userDimensionValueOrgMapper;
    @Autowired
    protected MyUserMapper myUserMapper;
    @Autowired
    protected ServiceTypeMapper serviceTypeMapper;
    @Autowired
    protected StatisticAttributeDimensionMapper statisticAttributeDimensionMapper;
    @Autowired
    protected RoleCategoryMapper roleCategoryMapper;
    @Autowired
    protected RoleMapper roleMapper;
    @Autowired
    protected UserDimensionValueMapper userDimensionValueMapper;
    @Autowired
    protected UserDimensionValueRoleMapper userDimensionValueRoleMapper;
    @Autowired
    protected UserOrganizationRoleMapper userOrganizationRoleMapper;
    @Autowired
    protected UserOrganizationMapper userOrganizationMapper;
    @Autowired
    protected DictionaryMapper dictionaryMapper;
    @Autowired
    protected OrganizationStructureMapper organizationStructureMapper;
    @Autowired
    protected IndustryMapper industryMapper;
}
