﻿commonModule.
controller('orgSelectorModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', '$filter', 'SweetAlert', 'orgService', 'userService','$rootScope',
function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, $filter, SweetAlert, orgService, userService,$rootScope) {
        $scope.gridInstance = null;
        var modalSelector = '#addOrgModal';
        var showWarning = function (resultMsg) {
            var errMsg = $translate.instant(resultMsg);
            SweetAlert.warning(errMsg);
        };

        var showSuccessMsg = function (resultMsg) {
            var errMsg = $translate.instant(resultMsg);
            SweetAlert.success(errMsg);
        };

        $(".addOrgModal").on("hidden.bs.modal", function () {
        });

        $scope.$watch("operation", function (newValue, oldValue) {
            if ($scope.operation.type === 'open') {
                $scope.selectedOrgList = [];
                $scope.selectedKeyItems = angular.copy($scope.selectedOrgs);
                getOrgList();
                $(modalSelector).modal("show");
                isOpened = true;
            }
        });

        //$scope.$on("openOrgSelectorModel", function (event,data) {
        //    $scope.selectedOrgList = [];
        //    //copy = data;
        //    data = [];
        //    $scope.selectedKeyItems = angular.copy(data);;
        //    getOrgList();
        //    $(modalSelector).modal("show");
        //});

        $scope.Save = function ()
        {
            $scope.selectedOrgs = $scope.selectedKeyItems;
            $rootScope.$broadcast('orgsChanged', $scope.selectedKeyItems);

            $(modalSelector).modal("hide");
        };

        var setSelectItems=function(selectedKeyItems)
        {
            //设置选中
            $timeout(function () {
                $scope.gridInstance.clearSelection();
                if (selectedKeyItems && selectedKeyItems.length > 0) {
                    $scope.gridInstance.selectRows(selectedKeyItems, true);
                }
            }, 100); 
        };

        var getOrgList = function () {
            if (!$scope.DataGridSource) {
                orgService.getOrgListLevel().success(function (data) {
                    if (data) {
                        $scope.DataGridSource = data;
                        setSelectItems($scope.selectedKeyItems);
                    }
                });
            }
            else {
                setSelectItems($scope.selectedKeyItems);
            }
        };

        var loadDatagrid = function () {
            $scope.orgDataGridOptions = {
                bindingOptions: {
                    dataSource: 'DataGridSource'
                }, 
                columns: [
                        {
                            dataField: "name",
                            caption: $translate.instant('OrganizationName'),
                            width:200
                        },
                        {
                            dataField: "businessUnitName",
                            caption: $translate.instant('BusinessUnit')
                        },
                        {
                            dataField: "areaName",
                            caption: $translate.instant('AreaTitleName'),
                            width:100
                        },
                        {
                            dataField: "industryName",
                            caption: $translate.instant('PIndustry')
                        }
                ],

                loadPanel: {
                    enabled: true
                },
                scrolling: {
                    mode: "virtual"
                },
                keyExpr: "id",
                parentIdExpr: "parentID",
                selection: {
                    mode: "multiple",
                    showCheckBoxesMode: "always",
                    allowSelectAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                autoExpandAll: true,
             
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                showBorders: true,
                //sorting: {
                //    mode: "none"
                //},
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width:518,
                    visible: true
                },
                onInitialized: function (e) {
                    $scope.gridInstance = e.component;
                },
                onSelectionChanged: function (e) {
                    //只有orgID List
                    $scope.selectedKeyItems = e.selectedRowKeys;;
                },
                onRowPrepared: function (e) {
                    //if (e && e.data) {
                    //    if ($scope.originalList.indexOf(e.data.id) > -1)
                    //    {
                    //        e.rowElement.addClass("dx-state-disabled");
                    //    }
                    //}
                },
                onContentReady: function (e, container)
                {
                }
            };

        };

        (function initialize() {
            $log.debug('addExistOrganizationModalController.ctor()...');
        
            loadDatagrid();
           // showModal();
        })();
    }
]);
