﻿// web service proxy for project
webservices.factory('projectService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getServiceList: function () {
            return $http.get('/project/listService', apiConfig.create());
        },
        getProjectList: function (orgID, serviceID, projectYear) {
            return $http.get('/project/display?orgID=' + orgID + '&serviceID=' + serviceID + '&projectYear=' + projectYear, apiConfig.create());
        },
        getOneProjectByDbNameServiceIdAndPeriodId: function (dbName, serviceID, periodId) {
            return $http.get('/project/getOneProjectByDbNameServiceIdAndPeriodId?dbName=' + dbName + '&serviceID=' + serviceID + '&periodId=' + periodId, apiConfig.create());
        },
        

        getAllProjectList: function (orgID, serviceID, projectYear) {
            return $http.get('/project/getAllProjectList?orgID=' + orgID + '&serviceID=' + serviceID + '&projectYear=' + projectYear, apiConfig.create());
        },
        getProjectByID: function (projectID) {
            return $http.get('/project/getProject?projectID=' + projectID, apiConfig.create());
        },
        getProjectExceptSelected: function (userId) {
            return $http.get('/project/displayExceptSelected?userID=' + userId, apiConfig.create());
        },
        getSingleProject: function (projectID) {
            return $http.get('/project/displaySingle?projectID=' + projectID, apiConfig.create());
        },
        addProject: function (projectDto) {
            return $http.post('/project/add', projectDto, apiConfig.create());
        },
        updateProject: function (projectDto) {
            return $http.put('/project/update', projectDto, apiConfig.create());
        },
        getProjectClientList: function (projectID) {
            return $http.get('/project/getProjectClientList', apiConfig.create());
        },
        getProjectStatus: function (dbName, projectId, periodId) {
            return $http.get('/ProjectStatusManage/getProjectStatus/' + dbName + '/' + projectId + '/' + periodId, apiConfig.createVat());
        },
        setProjectStatus: function (dbName, periodId, status) {
            return $http.get('/ProjectStatusManage/setProjectStatus/' + dbName + '/' + periodId + '/' + status, apiConfig.createVat());
        },
        isImportedAnyData: function (periodId,projectId) {
            return $http.get('/ProjectStatusManage/isImportedAnyData/' + periodId + '/' + projectId, apiConfig.createVat());
        },
        isProjectStatusExisted: function (dbName, periodId) {
            return $http.get('/ProjectStatusManage/isProjectStatusExisted/' + dbName + '/' + periodId, apiConfig.createVat());
        },
        getProjectAllStatus: function (dbName) {
            return $http.get('/project/getProjectAllStatus/' + dbName, apiConfig.create());
        }
    };
}]);